#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <time.h>
#include <unistd.h>
#include "config.h"
#include "msgqueue.h"
#define MAXSIZE 4096

typedef struct {
    long mtype;
    char mtext[MAXSIZE];
} mymsg_t;

int main(int argc, char* argv[]) {
    // mymsg used for sending/receiveing messages
    mymsg_t mymsg;

    // getting the process control blocks from shared memory
    int segment_id;
    segment_id = atoi(argv[1]);
    pcb_t* pcbs;
    pcbs = (pcb_t*) shmat(segment_id, NULL, 0);

    // getting the system clock
    segment_id = atoi(argv[3]);
    int* sysclock;
    sysclock = (int*) shmat(segment_id, NULL, 0);

    // getting this process' logical pid
    int lpid;
    lpid = atoi(argv[2]);
    
    // setting process' pid and seeding rand
    int termflag = 0;
    pcbs[lpid].pid = getpid();
    srand(getpid());

    // determining the processes time slice
    int timeslice = pcbs[lpid].timeslice;

    for(;;) {
        // recording and waiting for message from oss
        pcbs[lpid].waitstartsec = sysclock[0];
        pcbs[lpid].waitstartns = sysclock[1];        
        msgrcv(pcbs[lpid].msgqueueid, &mymsg, sizeof(mymsg), lpid+2, 0);

        // determining if the process is to be blocked
        int isblocked = rand() % 5;
        strcpy(mymsg.mtext, "R");
        if (pcbs[lpid].isIO)
            if (isblocked < 3) {
                pcbs[lpid].unblocksec = rand() % 5;
                pcbs[lpid].unblockns = rand() % 1000;
                strcpy(mymsg.mtext, "B");
            }
        if (!pcbs[lpid].isIO)
            if (isblocked < 2) {
                strcpy(mymsg.mtext, "B");
                pcbs[lpid].unblocksec = rand() % 5;
                pcbs[lpid].unblockns = rand() % 1000;
            }

        // determining if process should be terminated
        int istermed = rand() % 100;
        if (istermed <= LIKELIHOOD_TERM) {
            strcpy(mymsg.mtext, "T");
            termflag = 1;
        }
        
        // sending message to oss
        mymsg.mtype = 22;
        if (mymsg.mtext[0] == 'B' || mymsg.mtext[0] == 'T')
            pcbs[lpid].nanoseconds = rand() % timeslice;
        else
            pcbs[lpid].nanoseconds = timeslice;
        msgsnd(pcbs[lpid].msgqueueid, &mymsg, sizeof(mymsg), 0);

        // if termed, exit
        if (termflag) {
            exit(EXIT_SUCCESS);
        }
    }
    exit(EXIT_SUCCESS);
}
